/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.supinfo.spitfireboard.servlets;

import com.supinfo.spitfireboard.dao.PostDao;
import com.supinfo.spitfireboard.entities.Post;
import com.supinfo.spitfireboard.entities.User;
import com.supinfo.spitfireboard.services.ForumService;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.ejb.EJB;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;

/**
 *
 * @author mathilde
 */
@ManagedBean
@RequestScoped
public class PostController {
    
    @EJB
    private ForumService forumService;
    
    private String getValue(String fieldName) {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        return (String) facesContext.getExternalContext().getRequestParameterMap().get(fieldName);
    }
    
    private Long getPostId() {
        FacesContext facesContext = FacesContext.getCurrentInstance();
        String idStr = (String) facesContext.getExternalContext().getRequestParameterMap().get("id");
        if (idStr == null) {
            return null;
        }
        return Long.valueOf(idStr);
    }
    
    public User getLoggedUser() {
        return (User) FacesContext.getCurrentInstance().getExternalContext().getSessionMap().get("user");
    }
    
    public Post getPost() {
        return forumService.getPost(this.getPostId());
    }
    
    public List<String> doPost(){
        List<String> errors = new ArrayList<String>();
        
        //Check if text field is empty
        if (this.getValue("textField").equals("")) {
            errors.add("You didn't write anything!");
        }
        
        else {
            //DB Insert
            Long postId = null;
            try {
                postId = forumService.newPost(
                        this.getValue("textField"), 
                        Long.valueOf(this.getValue("topicId")), 
                        this.getLoggedUser().getId());
            }
            catch (Exception ex) {
                errors.add("Oops! Something wrong appened.");
                return errors;
            }
            
            // Redirect
            ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
            try {
                context.redirect("topic.xhtml?id=" + this.getValue("topicId") + "#post-" + postId);
            } catch (IOException ex) {
                Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
            }
                
        }
        
        return errors;
    }
    
    public List<String> doDelete() {
        List<String> errors = new ArrayList<String>();
        
        Long topicId = null;
        
        try {
            topicId = forumService.getPost(this.getPostId()).getTopicId();
            forumService.deletePost(this.getPostId());
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        // Redirect
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("topic.xhtml?id=" + topicId);
        } catch (IOException ex) {
            Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return null;
    }
    
    public List<String> doEdit() {
        List<String> errors = new ArrayList<String>();
        
        Long topicId = null;
        
        try {
            topicId = forumService.getPost(Long.valueOf(this.getValue("postId"))).getTopicId();
            forumService.postEdit(Long.valueOf(this.getValue("postId")), this.getValue("message"));
        }
        catch (Exception ex) {
            errors.add("Oops! Something wrong appened.");
            return errors;
        }
        
        // Redirect
        ExternalContext context = FacesContext.getCurrentInstance().getExternalContext();
        try {
            context.redirect("topic.xhtml?id=" + topicId + "#post-" + this.getValue("postId"));
        } catch (IOException ex) {
            Logger.getLogger(TopicController.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        return null;
    }
}
